﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace KingOfTheJungle
{
    /// <summary>
    /// Interaction logic for MainUserControl.xaml
    /// </summary>
    public partial class MainUserControl : UserControl
    {
        public MainWindow owner = null;

        public System.Random rnd = new Random();

        public MainUserControl()
        {
            InitializeComponent();
            initialize_game();
            show_room();
            szActionDescription =
                "   Just after a recent nuclear test in Africa, a giant lion appeared in a small\n" +
                "village, demanding everyone to leave.  None of the weapons the tribe had did\n" +
                "anything to it, as it thundered around the place, killing anyone in its path.\n" +
                "   Eventually, everyone finally left.  Those who remained were killed by some\n" +
                "unknown means.  Armed with only a hunting rifle, you must now stop this King of\n" +
                "the Jungle.\n";
            textBox1.Focus();
        }

        protected override void OnRender(DrawingContext drawingContext)
        {
            base.OnRender(drawingContext);
            DrawContents(drawingContext);
        }

        string szRoomDescription;
        string szActionDescription;
        void trim_action_text()
        {
	        while (szActionDescription.Length > 2048)
	        {
                int index = szActionDescription.IndexOf ('\n');
		        if (index == -1)
			        return;
                szActionDescription = szActionDescription.Substring (index + 1);
	        }
        }

        void initialize_game()
        {
            p = new place[]
            {
	            new place ("", 0, 0, 0, 0, 0, 0 ),
	            new place ("You are in a deserted village", 0, 0, 4, 0, 0, 0),
                new place ("You are in a wooden barn", 0, 1, 0, 0, 0, 0),
                new place ("You are in a ceremonial grass hut", 1, 0, 0, 12, 0, 0),
                new place ("You are in a deserted village", 0, 6, 7, 1, 0, 0),
                new place ("You are in an abandoned wizard's quarters", 0, 4, 0, 0, 0, 0),
                new place ("You are in a forest by a stream", 4, 0, 0, 0, 0, 0),
                new place ("You're at the foot of a mountain", 8, 0, 0, 4, 9, 0),
                new place ("You are in a bamboo nursery", 0, 7, 0, 0, 0, 0),
                new place ("You're on top of a mountain", 0, 0, 0, 0, 0, 7),
                new place ("You are in mid-air above a deep pit.  Your pole is keeping you from\n"
                    + "falling", 0, 0, 0, 0, 9, 16),
                new place ("You are in a small walk-in wardrobe closet", 0, 5, 0, 0, 0, 0),
                new place ("You are in the armory room", 0, 0, 3, 0, 0, 0),
                new place ("You are in a \"T\" intersection", 16, 0, 14, 15, 0, 0),
                new place ("You are in a temple built out of the cave's walls.  The place was evidently\n"
                    + "built in haste, then abandoned.  No human has entered this mistake for quite\n"
                    + "some time", 0, 0, 0, 13, 0, 0),
                new place ("You are in a narrow crawlway with rocky walls", 0, 0, 13, 0, 0, 0),
                new place ("You are in a deep pit with charred walls", 0, 13, 0, 0, 0, 0),
                new place ("You are in the cave lair of the lion", 0, 0, 15, 0, 0, 0)
            };

            ob = new adventure_object[]
            {
	            new adventure_object ("", 0),
	            new adventure_object ("Cow", 2),
	            new adventure_object ("Barn", 1),
	            new adventure_object ("Grass hut", 1),
	            new adventure_object ("Dead native", 4),
	            new adventure_object ("Sturdy cabin", 4),
	            new adventure_object ("Hole in the ground", 9),
	            new adventure_object ("Bottom end of rope", 16),
	            new adventure_object ("= Giant snake king =", 13),
	            new adventure_object ("Statue of lion", 14),
	            new adventure_object ("= King of the Jungle =", 17),
	            new adventure_object ("Bamboo trees", 8),
	            new adventure_object ("Strange dark stream", 6),
	            new adventure_object ("Radiation field", 15),
	            new adventure_object ("Held portal", 5),
	            new adventure_object ("Closed door", 0),
	            new adventure_object ("Hand churn", 2),
	            new adventure_object ("Bucket of buttermilk", 0),
	            new adventure_object ("Medicine kit", 3),
	            new adventure_object ("Scruffed-up shield", 12),
	            new adventure_object ("Chrome shield", 0),
	            new adventure_object ("Pot of oil", 11),
	            new adventure_object ("Sparker", 12),
	            new adventure_object ("Lit oil", 0),
	            new adventure_object ("Ancient scroll", 5),
	            new adventure_object ("Blank scroll", 0),
	            new adventure_object ("Rod of cancellation", 5),
	            new adventure_object ("Empty bucket", 2),
	            new adventure_object ("Bucket of raw milk", 0),
	            new adventure_object ("Piece of fine cloth", 11),
	            new adventure_object ("Bucket of strange liquid", 0),
	            new adventure_object ("Bamboo pole", 0),
	            new adventure_object ("Dirty old rope", 0),
	            new adventure_object ("Rope tied to pole", 0),
	            new adventure_object ("Piece of cheese", 0),
	            new adventure_object ("Very high powered rifle", 18),
	            new adventure_object ("Scrawled note", 0),
	            new adventure_object ("Shovel", 9)
            };

            cp = 1;
            aiming = false;
            drinkState = 0;
            lionEatingCheese = false;
            snakes = true;
        }

        void show_room()
        {
	        string [] dir = new string[]
	        {
		        "North", "South", "East", "West", "Up", "Down"
	        };

            if (cp > 12  &&  ob[23].room != cp  &&  ob[23].room != 18)
                szRoomDescription = "It's too dark to see!";
            else
            {
	            szRoomDescription = p[cp].name + ".";
	            bool foundOne = false;
                int charColumn = 0;
                for (int i = 1; i < ob.Length; ++i)
		            if (ob[i].room == cp)
		            {
			            if (!foundOne)
			            {
				            szRoomDescription += "  Visible items:\n\n";
                            foundOne = true;
			            }
                        if (ob[i].name.Length + charColumn > 77)
                        {
                            szRoomDescription += "\n";
                            charColumn = 0;
                        }
                        szRoomDescription += ob[i].name + ".  ";
                        charColumn += ob[i].name.Length + 3;
                    };
	            foundOne = false;
	            for (int i = 0; i <= 5; ++i)
		            if (p[cp].exit[i] != 0)
		            {
			            if (!foundOne)
			            {
				            szRoomDescription += "\n\nObvious exits:";
				            foundOne = true;
			            }
			            szRoomDescription += " " + dir[i];
		            }
            }
            if (textBox1.Visibility != System.Windows.Visibility.Hidden)
            {
                if (cp == 16 && snakes)
                {
                    szActionDescription += "You're attacked by man-eating snakes!  You're dead.";
                    adventure_over();
                }
                if (ob[10].room == cp)
                    if (!lionEatingCheese  &&  rnd.Next (1, 5) == 1)
                    {
                        szActionDescription += "The lion attacks you with a mental blast!  You're mindless.";
                        adventure_over();
                    }
                if (ob[8].room == cp)
                    if (rnd.Next(1, 4) == 1)
                    {
                        szActionDescription += "The snake's eyes shoot beams of coherent light at you!\n";
                        if (rnd.Next (1,3) == 1)
                            szActionDescription += "They miss, vaporizing a portion of the ground.\n";
                        else
                        {
                            if (ob[19].room == 18)
                                szActionDescription += "They penetrate right through your shield, and then\n";
                            if (ob[20].room != 18)
                            {
                                szActionDescription += "They penetrate right through you!  You're dead!\n";
                                adventure_over();
                            }
                            else if (!aiming)
                                szActionDescription += "You successfully deflect them with your shield.\n";
                            else
                            {
                                szActionDescription += "They bounce right back to the giant snake!\n" +
                                    "The snake is dead.  His head falls, then his whole body vanishes before his\n"
                                    + "head hits the ground.\n";
                                ob[8].room = 0;
                                show_room();
                            }
                        }
                    }
            }
        }

        void DrawContents(DrawingContext dc)
        {
            Point upperLeftCornerOfTextBox = textBox1.TranslatePoint(new Point(0, 0), this);

            FormattedText ft = new FormattedText(szActionDescription,
                System.Globalization.CultureInfo.CurrentCulture, System.Windows.FlowDirection.LeftToRight,
                new Typeface("Verdana"), 12, System.Windows.Media.Brushes.Black);
            dc.DrawText (ft, new Point(5, upperLeftCornerOfTextBox.Y - ft.Height - 5));

            ft = new FormattedText(szRoomDescription,
                System.Globalization.CultureInfo.CurrentCulture, System.Windows.FlowDirection.LeftToRight,
                new Typeface("Verdana"), 12, Brushes.Black);
            dc.DrawRectangle (Brushes.White, null, new Rect (0, 0, 2000, ft.Height + 12));
            dc.DrawText(ft, new Point(5, 5));
            dc.DrawLine (new Pen (Brushes.Black, 1), new Point (0, ft.Height + 10),
                         new Point (2000, ft.Height + 10));
            
            if (textBox1.Visibility == System.Windows.Visibility.Visible)
            {
                ft = new FormattedText ("  ------> What now? ",
                    System.Globalization.CultureInfo.CurrentCulture, System.Windows.FlowDirection.LeftToRight,
                    new Typeface("Verdana"), 12, System.Windows.Media.Brushes.Black);
                dc.DrawText (ft, new Point (5, upperLeftCornerOfTextBox.Y + 4));
            }
        }

        private void textBox1_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.Key == Key.Enter)
            {
                // The user pressed enter.  Process the command.
                string szCommand = textBox1.Text;
                if (lionEatingCheese)
                {
                    szActionDescription += "  ------> What now? " + szCommand + "\n";
                    if (szCommand.Length > 4)
                        szCommand = szCommand.Substring (0, 4);
                    if (szCommand.ToUpper() == "FIRE"  ||  szCommand.ToUpper() == "SHOO")
                        if (ob[35].room != 18)
                        {
                            szActionDescription += "You don't have a gun.\n";
                            szActionDescription += "The lion finishes eating, then has you for dessert!\n";
                        }
                        else
                            szActionDescription +=
                                "You blew away half his body!  He falls to the ground, writhing in pain and\n" +
                                "agony.  His blood spills out on the floor as he gives his last cry, and dies.\n" +
                                "Congratulations!  You've ridden the world of a monstrously lethal menace.\n";
                    else
                        szActionDescription += "The lion finishes eating, then has you for dessert!\n";
                    adventure_over();
                }
                else
                {
                    int verb;
				    NounType noun;
                    if (input_command (szCommand, out verb, out noun))
                        do_command(verb, noun);
                }
                textBox1.Text = string.Empty;
                trim_action_text();
                InvalidateVisual();
            }
        }


        struct place
        {
	        public string name;
	        public int [] exit;    // 6 exits, one for each direction
            public place (string theName, int north, int south, int east, int west, int up, int down)
            {
                exit = new int[6];
                name = theName;
                exit[0] = north;
                exit[1] = south;
                exit[2] = east;
                exit[3] = west;
                exit[4] = up;
                exit[5] = down;
            }
        };
        place[] p;

        struct adventure_object
        {
	        public string name;
	        public int room;    // if room == 18, it's in your inventory
            public adventure_object (string theName, int startingRoom)
            {
                name = theName;
                room = startingRoom;
            }
        };
        adventure_object[] ob;

        int cp; // the Current Place in the adventure
        bool aiming;
        int drinkState; // 0 = haven't drunken anything, 1 = buttermilk, 2 = anti-toxin, 3 = lead solution
        bool lionEatingCheese;
        bool snakes;    // Why'd it have to be snakes?
        
        string verb_str, noun_str;
        enum NounType
        {
            none,
            NORT, SOUT, EAST, WEST, UP, DOWN,
            INVE,
            COW,
            BARN,
            HUT,    // 10
            NATI,
            CABI,
            QUAR,
            HOLE,
            pound_sign,
            SNAK,
            STAT,
            LION, KING, // I came up with this game a decade before the Disney movie.  So there.
            BAMB,   // 20
            TREE,
            STRE,
            RADI, FIEL,
            PORT, DOOR,
            CHUR,
            BUCK,
            BUTT,
            MILK,   // 30
            MEDI, KIT,
            ANTI,
            SHIE,
            POT, OIL,
            SPAR,
            SCRO,
            ROD,
            CLOT,   // 40
            LIQU,
            LEAD,
            SOLU,
            POLE,
            ROPE,
            CHEE,
            RIFL,
            NOTE,
            FING,
            GAME,   // 50
            SHOV,
            last
        }

        private bool input_command (string szCommand, out int verb, out NounType noun)
        {
	        string [] verb_table = new string[]
	        {
		        "",
		        "N", "S", "E", "W", "U", "D",
		        "GO", "CLIM", "ENTE",
		        ".", "GET", "TAKE",
		        "P", "PUT", "DROP",
		        "I", "INVE",
		        "HELP",
		        "QUIT",
		        "L", "LOOK", "EXAM",
		        "DIG",
		        "FRIS", "SEAR",
                "FIRE", "SHOO",
                "LIGH",
                "UNLI",
		        "OPEN",
                "KICK",
                "READ",
                "FILL",
                "EMPT",
                "MILK",
                "POLI", "SHIN",
                "TOUC",
		        "KILL",
                "BREA",
                "CHUR",
                "DRIN",
                "TIE",
		        "EAT",
		        "AIM",
		        "THRO",
		        "DISP",
		        "SQUE",
		        "SCOR",
                "SAVE",
                "LOAD",
                "POIN",
                "WAIT"
	        };
	        string [] noun_table = new string[]
	        {
		        "",
		        "NORT", "SOUT", "EAST", "WEST", "UP", "DOWN",
                "INVE",
		        "COW",
		        "BARN",
		        "HUT",
		        "NATI",
		        "CABI",
		        "QUAR",
		        "HOLE",
		        "#",
		        "SNAK",
		        "STAT",
		        "LION", "KING", // No, really.  Please don't sue me, Michael Eisner!
		        "BAMB",
                "TREE",
		        "STRE",
		        "RADI", "FIEL",
		        "PORT", "DOOR",
		        "CHUR",
		        "BUCK",
                "BUTT",
		        "MILK",
		        "MEDI", "KIT",
		        "ANTI",
		        "SHIE",
                "POT", "OIL",
		        "SPAR",
                "SCRO",
		        "ROD",
		        "CLOT",
		        "LIQU",
                "LEAD",
                "SOLU",
                "POLE",
                "ROPE",
                "CHEE",
                "RIFL",
                "NOTE",
                "FING",
                "GAME",
                "SHOV"
	        };
            verb = 0;
            noun = NounType.none;

	        verb_str = string.Empty;
	        noun_str = string.Empty;

	        szActionDescription += "  ------> What now? " + szCommand + "\n";
	        int i = 0;
	        while (i < szCommand.Length  &&  szCommand[i] != ' ')
		        ++i;
	        verb_str = szCommand.Substring (0, i);
	        if (i < 30)
	        {
		        int j = i;
		        while (j < szCommand.Length  &&  szCommand[j] == ' ')
			        ++ j;
		        if (j < szCommand.Length)
			        noun_str = szCommand.Substring (j);
	        }
            string verbStrToCompare = verb_str;
            if (verbStrToCompare.Length > 4)
                verbStrToCompare = verbStrToCompare.Substring (0,4);
            verbStrToCompare = verbStrToCompare.ToUpper();
            i = 1;
            while (i < verb_table.Length && verbStrToCompare != verb_table[i])
		        ++i;
            if (i < verb_table.Length)
		        verb = i;
	        else
	        {
		        szActionDescription += "I don't know how to \"" + verb_str + "\" something.\n";
		        return false;
	        }
	        if (noun_str != string.Empty)
	        {
                string nounStrToCompare = noun_str;
                if (nounStrToCompare.Length > 4)
                    nounStrToCompare = nounStrToCompare.Substring(0, 4);
                nounStrToCompare = nounStrToCompare.ToUpper();
                NounType n = NounType.none;
                ++n;
                while (n < NounType.last && nounStrToCompare != noun_table[(int)n])
                    ++n;
                if (n < NounType.last)
                    noun = n;
                else
                {
                    szActionDescription += "I don't know what \"" + noun_str + "\" is.\n";
                    return false;
                }
            }
            return true;
        }

        // Master verb function chooser, derived from BASIC on-goto statement.
        private void do_command(int verb, NounType noun)
        {
            switch (verb)
            {
                case 1:
                case 2:
                case 3:
                case 4:
                case 5:
                case 6:
                    move_dir (verb-1);
                    break;
                case 7:
                case 8:
                case 9:
                    verb_go (noun);
                    break;
                case 10:
                case 11:
                case 12:
                    verb_take(noun);
                    break;
                case 13:
                case 14:
                case 15:
                    verb_drop(noun);
                    break;
                case 16:
                case 17:
                    verb_inventory();
                    break;
                case 18:
                    verb_help();
                    break;
                case 19:
                    adventure_over();
                    break;
                case 20:
                case 21:
                case 22:
                    verb_look (noun);
                    break;
                case 23:
                    verb_dig();
                    break;
                case 24:
                case 25:
                    verb_frisk(noun);
                    break;
                case 26:
                case 27:
                    verb_fire();
                    break;
                case 28:
                    verb_light (noun);
                    break;
                case 29:
                    verb_unlight (noun);
                    break;
                case 30:
                    verb_open(noun);
                    break;
                case 31:
                    verb_kick();
                    break;
                case 32:
                    verb_read (noun);
                    break;
                case 33:
                    verb_fill (noun);
                    break;
                case 34:
                    verb_empty (noun);
                    break;
                case 35:
                    verb_milk (noun);
                    break;
                case 36:
                case 37:
                    verb_polish (noun);
                    break;
                case 38:
                    verb_touch (noun);
                    break;
                case 39:
                    verb_kill(noun);
                    break;
                case 40:
                    verb_break(noun);
                    break;
                case 41:
                    verb_churn();
                    break;
                case 42:
                    verb_drink (noun);
                    break;
                case 43:
                    verb_tie (noun);
                    break;
                case 44:
                    verb_eat (noun);
                    break;
                case 45:
                    verb_aim (noun);
                    break;
                case 46:
                    verb_throw(noun);
                    break;
                case 47:
                    verb_dispel (noun);
                    break;
                case 48:
                    verb_squeeze (noun);
                    break;
                case 49:
                    verb_score();
                    break;
                case 50:
                    verb_save();
                    break;
                case 51:
                    verb_load();
                    break;
                case 52:
                    verb_aim (noun);
                    break;
                case 53:
                    szActionDescription += "Hum de dum...\n";
                    break;
            }
            show_room();
        }

        private void move_dir(int direc)
        {
            if (cp > 12  &&  ob[23].room != 18  &&  ob[23].room != cp)
            {
                szActionDescription += "It's dangerous to move in the dark!\n";
                if (p[cp].exit[direc] == 0)
                {
                    szActionDescription += "You fell & broke your neck!  You're dead!\n";
                    adventure_over();
                    return;
                }
            }
	        if (p[cp].exit[direc] == 0)
		        szActionDescription += "There is no way to go that direction.\n";
            else if (ob[8].room == cp  &&  direc > 1)
                szActionDescription += "The snake won't let you leave!\n";
            else if (cp == 10  &&  direc == 5  &&  ob[33].room != cp)
            {
                szActionDescription += "You fall fifty feet to your death!\n";
                adventure_over();
            }
            else
	        {
    		    cp = p[cp].exit[direc];
                aiming = false;
		        szActionDescription += "Ok\n";
	        }
        }

        private void verb_go(NounType noun)
        {
            switch (noun)
            {
                case NounType.none:
                    verb_what();
                    break;
                case NounType.NORT:
                case NounType.SOUT:
                case NounType.EAST:
                case NounType.WEST:
                case NounType.UP:
                case NounType.DOWN:
                    move_dir((int)noun - (int) NounType.NORT);
                    break;
                case NounType.BARN:
                    if (ob[2].room != cp)
                        szActionDescription += "You don't see it here.\n";
                    else
                    {
                        szActionDescription += "Ok\n";
                        cp = 2;
                    }
                    break;
                case NounType.HUT:
                    if (ob[3].room != cp)
                        szActionDescription += "You don't see it here.\n";
                    else
                    {
                        szActionDescription += "Ok\n";
                        cp = 3;
                    }
                    break;
                case NounType.CABI:
                case NounType.QUAR:
                    if (ob[5].room != cp)
                        szActionDescription += "You don't see it here.\n";
                    else
                    {
                        szActionDescription += "Ok\n";
                        cp = 5;
                    }
                    break;
                case NounType.RADI:
                case NounType.FIEL:
                    if (ob[13].room != cp)
                        szActionDescription += "You don't see it here.\n";
                    else if (drinkState != 3)
                    {
                        szActionDescription += "The radiation was too strong for your body to handle!\n"
                            + "You die of cancer in less than a second.\n";
                        adventure_over();
                    }
                    else
                    {
                        szActionDescription += "Ok\n";
                        cp = 17;
                    }
                    break;
                case NounType.HOLE:
                    if (ob[6].room != cp)
                        szActionDescription += "You don't see it here.\n";
                    else if (ob[31].room != 18 && ob[31].room != cp &&
                             ob[33].room != 18 && ob[33].room != 10)
                    {
                        szActionDescription += "AAAAAAHHHH!  The hole was the entrance to a fifty foot deep pit!\n"
                            + "You fall through the air and crash down on the hard ground, dying on impact.\n";
                        adventure_over();
                    }
                    else
                    {
                        cp = 10;
                        if (ob[33].room == 18)
                        {
                            ob[33].room = cp;
                            szActionDescription += "Klunk!\n";
                        }
                    }
                    break;
                case NounType.ROPE:
                    if (ob[7].room != cp)
                        szActionDescription += "You don't see it here.\n";
                    else
                    {
                        szActionDescription += "Ok\n";
                        cp = 10;
                    }
                    break;
                default:
                    szActionDescription += "You can't go to a " + noun_str + ".\n";
                    break;
            }
        }

        private void verb_what()
        {
            szActionDescription += verb_str + " what?\n";
        }

        private int MapNounToObject (NounType noun, int room)
        {
            switch (noun)
            {
                case NounType.COW:
                    return 1;
                case NounType.BARN:
                    return 2;
                case NounType.HUT:
                    return 3;
                case NounType.NATI:
                    return 4;
                case NounType.CABI:
                    return 5;
                case NounType.HOLE:
                    return 6;
                case NounType.SNAK:
                    return 8;
                case NounType.STAT:
                    return 9;
                case NounType.LION:
                case NounType.KING:
                    return 10;
                case NounType.BAMB:
                    if (ob[31].room == room)
                        return 31;
                    else
                        return 11;
                case NounType.TREE:
                    return 11;
                case NounType.STRE:
                    return 12;
                case NounType.RADI:
                case NounType.FIEL:
                    return 13;
                case NounType.PORT:
                case NounType.DOOR:
                    if (ob[15].room == room)
                        return 15;
                    else
                        return 14;
                case NounType.CHUR:
                    return 16;
                case NounType.BUCK:
                    if (ob[27].room == room)
                        return 27;
                    else if (ob[28].room == room)
                        return 28;
                    else if (ob[30].room == room)
                        return 30;
                    else
                        return 17;
                case NounType.BUTT:
                    return 17;
                case NounType.MILK:
                    if (ob[28].room == room)
                        return 28;
                    else
                        return 17;
                case NounType.MEDI:
                case NounType.KIT:
                    return 18;
                case NounType.SHIE:
                    if (ob[20].room == room)
                        return 20;
                    else
                        return 19;
                case NounType.POT:
                    return 21;
                case NounType.OIL:
                    if (ob[23].room == room)
                        return 23;
                    else
                        return 21;
                case NounType.SPAR:
                    return 22;
                case NounType.SCRO:
                    if (ob[25].room == room)
                        return 25;
                    else
                        return 24;
                case NounType.ROD:
                    return 26;
                case NounType.CLOT:
                    return 29;
                case NounType.LIQU:
                    return 30;
                case NounType.POLE:
                    return 31;
                case NounType.ROPE:
                    if (ob[33].room == room)
                        return 33;
                    else
                        return 32;
                case NounType.CHEE:
                    return 34;
                case NounType.RIFL:
                    return 35;
                case NounType.NOTE:
                    return 36;
                case NounType.SHOV:
                    return 37;
            }
            return 0;
        }

        private void verb_take (NounType noun)
        {
            if (noun == NounType.none)
                verb_what();
            else if (noun >= NounType.NORT && noun <= NounType.UP)
                szActionDescription += "I don't get it.\n";
            else if (noun == NounType.DOWN)
                szActionDescription += "... and boogie!\n";
            else if (noun == NounType.INVE)
                verb_inventory();
            else if (noun < NounType.CHUR   ||
                     noun == NounType.FING  ||
                     noun == NounType.GAME  ||
                     noun == NounType.LIQU  ||
                     noun == NounType.LEAD  ||
                     noun == NounType.SOLU  ||
                     noun == NounType.BUTT  ||
                     noun == NounType.MILK)
                szActionDescription += "It's beyond your power to do that.\n";
            else
            {
                int numItemsCarried = 0;
                for (int i = 1; i < ob.Length; ++i)
                    if (ob[i].room == 18)
                        ++ numItemsCarried;
                if (numItemsCarried > 6)
                    szActionDescription += "You are currently holding too much. Try: TAKE INVENTORY\n";
                else
                {
                    int o = MapNounToObject (noun, cp);
                    if (ob[o].room != cp)
                        szActionDescription += "You don't see it here.\n";
                    else
                    {
                        szActionDescription += "Ok\n";
                        ob[o].room = 18;
                    }
                }
            }
        }

        private void verb_inventory()
        {
            szActionDescription += "You are currently holding the following:\n";
            bool foundOne = false;
            int charColumn = 0;
            for (int i = 0; i < ob.Length; ++i)
                if (ob[i].room == 18)
                {
                    foundOne = true;
                    if (ob[i].name.Length + charColumn > 77)
                    {
                        szActionDescription += "\n";
                        charColumn = 0;
                    }
                    szActionDescription += ob[i].name + ".  ";
                    charColumn += ob[i].name.Length + 3;
                }
            if (!foundOne)
                szActionDescription += "Nothing at all";
            szActionDescription += "\n";
        }

        private void verb_help()
        {
            szActionDescription += "I can't help you!  This is supposed to be a hard adventure!\n";
        }

        private void verb_drop (NounType noun)
        {
            if (noun == NounType.none)
                verb_what();
            else if (noun >= NounType.NORT && noun <= NounType.UP)
                szActionDescription += "I don't get it.\n";
            else if (noun == NounType.DOWN)
                if (verb_str.ToUpper() == "PUT")
                    szActionDescription += "You're ugly and your mother dresses you funny.\n";
                else
                    szActionDescription += "You flatten yourself against the ground, then get back up, embarrassed.\n";
            else
            {
                int o = MapNounToObject(noun, 18);
                if (ob[o].room != 18)
                    szActionDescription += "You don't have it.\n";
                else
                {
                    szActionDescription += "Ok\n";
                    ob[o].room = cp;
                }
            }
        }

        private void verb_look (NounType noun)
        {
            switch (noun)
            {
                case NounType.DOWN:
                    // Look down!  Look down!  Don't look 'em in the eye!
                    if (cp == 10)
                    {
                        szActionDescription += "You see a deep pit";
                        if (snakes)
                            szActionDescription += " with snakes at the bottom";
                        szActionDescription += ".\n";
                        return;
                    }
                    break;
                case NounType.STAT:
                case NounType.LION:
                    if (ob[9].room == cp  &&  ob[34].room == 0)
                    {
                        szActionDescription += "It's holding a piece of cheese.\n";
                        return;
                    }
                    break;
                case NounType.MEDI:
                case NounType.KIT:
                    if (ob[18].room != cp  &&  ob[18].room != 18)
                        szActionDescription += "You don't see it here.\n";
                    else
                        szActionDescription += "It contains a powerful anti-toxin.\n";
                    return;
                case NounType.NOTE:
                    if (ob[36].room != cp && ob[36].room != 18)
                        szActionDescription += "You don't see it here.\n";
                    else
                        szActionDescription += "There's writing on it.\n";
                    return;
                case NounType.SCRO:
                    if (ob[25].room == 0)
                    {
                        if (ob[24].room != cp  &&  ob[24].room != 18)
                            szActionDescription += "You don't see it here.\n";
                        else
                            szActionDescription += "There's a fireball spell written on it.\n";
                        return;
                    }
                    break;
                case NounType.NATI:
                    if (ob[4].room != cp)
                        szActionDescription += "You don't see it here.\n";
                    else
                        szActionDescription += "His body's intact, but his head is hollow!\n";
                    return;
                case NounType.HOLE:
                    if (ob[6].room != cp)
                        szActionDescription += "You don't see it here.\n";
                    else
                    {
                        szActionDescription += "You see a deep pit";
                        if (snakes)
                            szActionDescription += " with snakes at the bottom";
                        szActionDescription += ".\n";
                    }
                    return;
            }
            szActionDescription += "You see nothing special.\n";
        }

        private void verb_dig()
        {
            if (ob[37].room != 18)
                szActionDescription += "You have nothing to dig with.\n";
            else if (cp != 7  ||  ob[32].room != 0  ||  ob[33].room != 0)
                szActionDescription += "You found nothing.\n";
            else
            {
                szActionDescription += "You found something.\n";
                ob[32].room = 7;
            }
        }

        private void verb_frisk(NounType noun)
        {
            if (noun == NounType.none)
                verb_what();
            else if (noun != NounType.NATI)
                szActionDescription += "You can't " + verb_str + " a " + noun_str + ".\n";
            else if (ob[4].room != cp)
                szActionDescription += "You don't see it here.\n";
            else if (ob[36].room != 0)
                szActionDescription += "You found nothing.\n";
            else
            {
                szActionDescription += "You found something.\n";
                ob[36].room = cp;
            }
        }

        private void verb_fire()
        {
            if (ob[35].room != 18)
                szActionDescription += "You don't have a gun.\n";
            else if (ob[10].room == cp)
            {
                szActionDescription +=
                    "Even though the gun's kick throws you back to the other side of the room, the\n" +
                    "lion mentally stopped the bullets before they reached him.  He roars, advances,\n" +
                    "and tears you apart with a high powered mental blast.\n";
                adventure_over();
            }
            else
                szActionDescription += "Save your gun for something more important.\n";
        }

        private void verb_light (NounType noun)
        {
            if (noun == NounType.none)
                verb_what();
            else if (noun != NounType.POT  &&  noun != NounType.OIL)
                szActionDescription += "You can't " + verb_str + " a " + noun_str + ".\n";
            else if (ob[23].room != 0)
                szActionDescription += "It's already lit.\n";
            else if (ob[21].room != cp  &&  ob[21].room != 18)
                szActionDescription += "You don't see it here.\n";
            else if (ob[22].room != 18)
                szActionDescription += "You have nothing to light it with.\n";
            else
            {
                szActionDescription += "Ok\n";
                ob[23].room = ob[21].room;
                ob[21].room = 0;
            }
        }

        private void verb_unlight (NounType noun)
        {
            if (noun == NounType.none)
                verb_what();
            else if (noun != NounType.POT && noun != NounType.OIL)
                szActionDescription += "You can't " + verb_str + " a " + noun_str + ".\n";
            else if (ob[21].room != 0)
                szActionDescription += "It's not lit.\n";
            else if (ob[23].room != cp && ob[23].room != 18)
                szActionDescription += "You don't see it here.\n";
            else
            {
                szActionDescription += "Ok\n";
                ob[23].room = ob[21].room;
                ob[21].room = 0;
            }
        }

        private void verb_open(NounType noun)
        {
            if (noun == NounType.none)
                verb_what();
            else if (noun != NounType.DOOR)
                szActionDescription += "Oh, stop being weird.\n";
            else if (ob[15].room != cp)
                szActionDescription += "You don't see it here.\n";
            else
            {
                szActionDescription += "Ok\n";
                ob[15].room = 0;
                p[cp].exit[0] = 11;
            }
        }

        private void verb_kick()
        {
            szActionDescription += "You hurt your foot, but do nothing else.\n";
        }

        private void verb_read(NounType noun)
        {
            if (noun == NounType.none)
                verb_what();
            else if (noun == NounType.SCRO)
                if (ob[25].room == 18)
                    szActionDescription += "Blank scroll is blank.\n";
                else if (ob[24].room != 18)
                    szActionDescription += "You don't have it.\n";
                else
                {
                    ob[24].room = 0;
                    ob[25].room = 18;
                    szActionDescription += "A silvery line extends from your finger, and ignites a fireball\n";
                    if (!aiming)
                        szActionDescription += "in midair.\n";
                    else
                    {
                        szActionDescription += "down in the snake pit.  Nothing could survive such a blast.\n";
                        snakes = false;
                    }
                }
            else if (noun != NounType.NOTE)
                szActionDescription += "There is nothing written on a " + noun_str + ".\n";
            else if (ob[36].room != cp  &&  ob[36].room != 18)
                szActionDescription += "You don't see it here.\n";
            else
                szActionDescription +=
                    "The note says: \"I am a psychic.  The lion is actually a mutation of a regular\n" +
                    "lion due to the nuclear testing.  The giant is only his projected image in a\n" +
                    "material form, therefore none of our weapons could harm him.  Now, hurry and--\"\n" +
                    "The back of the note reads:\n" +
                    "Get \"Medieval Space Warrior\" Adventure for your TRS-80!\n";
        }

        private void verb_fill (NounType noun)
        {
            if (noun == NounType.none)
                verb_what();
            else if (noun != NounType.BUCK)
                szActionDescription += "You can't " + verb_str + " a " + noun_str + ".\n";
            else if (ob[27].room != 18  &&  ob[27].room != cp)
                szActionDescription += "You need an empty bucket to fill.\n";
            else if (ob[12].room != cp)
                szActionDescription += "There's nothing here to fill it from.\n";
            else
            {
                szActionDescription += "Ok\n";
                ob[30].room = ob[27].room;
                ob[27].room = 0;
            }
        }

        private void verb_empty (NounType noun)
        {
            if (noun == NounType.none)
                verb_what();
            else if (noun != NounType.BUCK)
                szActionDescription += "You can't " + verb_str + " a " + noun_str + ".\n";
            else if (ob[27].room != 0)
                szActionDescription += "It's not filled.\n";
            else if (ob[17].room == 18  ||  ob[17].room == cp)
            {
                szActionDescription += "Ok\n";
                ob[27].room = ob[17].room;
                ob[17].room = 0;
            }
            else if (ob[28].room == 18 || ob[28].room == cp)
            {
                szActionDescription += "Ok\n";
                ob[27].room = ob[28].room;
                ob[28].room = 0;
            }
            else if (ob[30].room != 18 && ob[30].room != cp)
                szActionDescription += "You don't see it here.\n";
            else
            {
                szActionDescription += "Ok\n";
                ob[27].room = ob[30].room;
                ob[30].room = 0;
            }
        }

        private void verb_milk (NounType noun)
        {
            if (noun == NounType.none)
                verb_what();
            else if (noun != NounType.COW)
                szActionDescription += "You can't " + verb_str + " a " + noun_str + ".\n";
            else if (ob[1].room != cp)
                szActionDescription += "You don't see it here.\n";
            else if (ob[27].room != 18 && ob[27].room != cp)
                szActionDescription += "It spills onto the ground.\n";
            else
            {
                szActionDescription += "Ok\n";
                ob[28].room = ob[27].room;
                ob[27].room = 0;
            }
        }

        private void verb_polish (NounType noun)
        {
            if (noun == NounType.none)
                verb_what();
            else if (noun != NounType.SHIE)
                szActionDescription += "You can't " + verb_str + " a " + noun_str + ".\n";
            else if (ob[20].room != 0)
                szActionDescription += "You've already done that.\n";
            else if (ob[19].room != 18)
                szActionDescription += "You aren't holding it.\n";
            else if (ob[29].room != 18)
                szActionDescription += "You're not carrying anything to " + verb_str + " it with.\n";
            else
            {
                szActionDescription += "Ok.  It is now shiny chrome.\n";
                ob[20].room = 18;
                ob[19].room = 0;
            }
        }

        private void verb_touch (NounType noun)
        {
            if (noun == NounType.none)
                verb_what();
            else if (noun == NounType.STAT  ||  noun == NounType.LION)
                szActionDescription += "Which part?\n";
            else if (noun == NounType.PORT)
                if (ob[26].room != 18)
                    szActionDescription += "Nothing happens\n";
                else if (ob[14].room != cp)
                    szActionDescription += "You don't see it here.\n";
                else
                {
                    szActionDescription += "Ok\n";
                    ob[15].room = cp;
                    ob[14].room = 0;
                }
            else if (noun == NounType.CHEE)
                if (ob[26].room != 18  ||  ob[34].room != 0)
                    szActionDescription += "Nothing happens\n";
                else if (ob[9].room != cp)
                    szActionDescription += "You don't see it here.\n";
                else
                {
                    szActionDescription += "You've dispelled it.  It falls to the ground.\n";
                    ob[34].room = cp;
                }
            else
                szActionDescription += "Nothing happens\n";
        }

        private void verb_kill (NounType noun)
        {
            if (noun == NounType.none)
                verb_what();
            else if (noun != NounType.LION  &&  noun != NounType.KING  &&  noun != NounType.SNAK)
                szActionDescription += "Oh, stop being weird.\n";
            else
                szActionDescription += "You're going to have to be more specific.\n";
        }

        private void verb_break(NounType noun)
        {
            // Unfortunately, one of the cute puns in the old BASIC versions can't be done here.
            // In BASIC, a STOP command would result in the words "BREAK AT <line number>" appearing
            // at the cursor position, followed by a standard BASIC command prompt.  If the user
            // entered the BREAK verb in the game with no noun following it, we'd execute a STOP.
            // But that joke doesn't carry over very well to a standalone WPF .NET application.
            if (noun == NounType.none)
                verb_what();
            else if (noun != NounType.BAMB  &&  noun != NounType.TREE)
                szActionDescription += "Oh, stop being weird.\n";
            else if (ob[31].room != 0  ||  ob[33].room != 0)
                szActionDescription += "You've already done that.\n";
            else if (ob[11].room != cp)
                szActionDescription += "You don't see it here.\n";
            else
            {
                szActionDescription += "Ok\n";
                ob[31].room = 18;
            }
        }

        private void verb_churn()
        {
            if (ob[16].room != 18)
                szActionDescription += "You aren't holding a churn.\n";
            else if (ob[28].room != 18  &&  ob[28].room != cp)
                szActionDescription += "There's nothing here that you can churn.\n";
            else
            {
                szActionDescription += "Ok\n";
                ob[17].room = ob[28].room;
                ob[28].room = 0;
            }
        }

        private void verb_drink (NounType noun)
        {
            if (noun == NounType.none)
                verb_what();
            else if (noun == NounType.BUTT)
                if (ob[17].room != cp  &&  ob[17].room != 18)
                    szActionDescription += "You don't see it here.\n";
                else
                {
                    szActionDescription += "Ok\n";
                    drinkState = 1;
                    ob[27].room = ob[17].room;
                    ob[17].room = 0;
                }
            else if (noun == NounType.MILK)
                if (ob[17].room == cp  ||  ob[17].room == 18)
                {
                    szActionDescription += "Ok\n";
                    drinkState = 1;
                    ob[27].room = ob[17].room;
                    ob[17].room = 0;
                }
                else if (ob[28].room != cp && ob[28].room != 18)
                    szActionDescription += "You don't see it here.\n";
                else
                {
                    szActionDescription += "It's loaded with bacteria!  You die of botulism!\n";
                    adventure_over();
                }
            else if (noun == NounType.ANTI)
                if (ob[18].room != cp && ob[18].room != 18)
                    szActionDescription += "You don't see it here.\n";
                else if (drinkState == 0)
                {
                    szActionDescription += "You got heartburn!  You're dead from an ulcer.\n";
                    adventure_over();
                }
                else
                {
                    szActionDescription += "Ok\n";
                    drinkState = 2;
                }
            else if (noun == NounType.LIQU  ||  noun == NounType.LEAD  ||  noun == NounType.SOLU)
                if (ob[30].room != cp && ob[30].room != 18)
                    szActionDescription += "You don't see it here.\n";
                else if (drinkState < 2)
                {
                    szActionDescription += "It was a solution of lead!  You're poisoned.\n";
                    adventure_over();
                }
                else
                {
                    szActionDescription += "Ok\n";
                    drinkState = 3;
                    ob[27].room = ob[30].room;
                    ob[30].room = 0;
                }
            else
                szActionDescription += "Oh, stop being weird.\n";
        }

        private void verb_tie (NounType noun)
        {
            if (noun == NounType.none)
                verb_what();
            else if (noun != NounType.ROPE)
                szActionDescription += "Oh, stop being weird.\n";
            else if (ob[32].room != 18)
                szActionDescription += "You aren't holding it.\n";
            else
            {
                WithWhatPrompt dlg = new WithWhatPrompt();
                dlg.PromptText = "To what?";
                dlg.ShowDialog();
                string response = dlg.Response;
                if (response.Length > 4)
                    response = response.Substring (0, 4);
                if (response.ToUpper() != "BAMB"  &&  response.ToUpper() != "POLE")
                    szActionDescription += "Sorry, it slips off.\n";
                else if (ob[31].room != 18)
                    szActionDescription += "You aren't holding it.\n";
                else
                {
                    szActionDescription += "Ok\n";
                    ob[31].room = 0;
                    ob[32].room = 0;
                    if (cp == 10)
                        ob[33].room = cp;
                    else
                        ob[33].room = 18;
                }
            }
        }

        private void verb_eat (NounType noun)
        {
            if (noun == NounType.none)
                verb_what();
            else if (noun != NounType.CHEE)
                szActionDescription += "Oh, stop being weird.\n";
            else if (ob[34].room != cp  &&  ob[34].room != 18)
                szActionDescription += "You don't see it here.\n";
            else
            {
                szActionDescription += "Ok.  It tasted great.  I guess statue cheese doesn't get stale.\n";
                ob[34].room = 0;
            }
        }

        private void verb_aim (NounType noun)
        {
            if (noun == NounType.none)
                verb_what();
            else if (noun == NounType.FING)
                szActionDescription += "Specify a direction.\n";
            else if (noun == NounType.DOWN  &&  (ob[6].room == cp  ||  cp == 10))
            {
                // Aim down!  Aim down!  Don't look 'em in the ... oh, wait.
                szActionDescription += "Ok\n";
                aiming = true;
            }
            else if (noun == NounType.SHIE)
                if (ob[19].room != 18  &&  ob[20].room != 18)
                    szActionDescription += "You aren't holding it.\n";
                else if (ob[8].room == cp)
                {
                    szActionDescription += "Ok\n";
                    aiming = true;
                }
                else
                    szActionDescription += "Nothing happens.\n";
            else
                szActionDescription += "Nothing happens.\n";
        }

        private void verb_throw (NounType noun)
        {
            if (noun == NounType.UP)
                szActionDescription += "Barf!\n";   // Thank you, Scott Adams' _Ghost Town_
            else if (noun != NounType.CHEE  ||  ob[10].room != cp  ||  ob[34].room != 18)
                verb_drop (noun);
            else
            {
                szActionDescription += "The lion goes after it, and is eating quickly.  Now's your chance!\n";
                lionEatingCheese = true;
            }
        }

        private void verb_dispel(NounType noun)
        {
            if (noun == NounType.none)
                verb_what();
            else
                szActionDescription += "Use a device to do your dispelling.  You're no wizard.\n";
        }

        private void verb_squeeze (NounType noun)
        {
            if (noun == NounType.none)
                verb_what();
            else if (noun != NounType.SPAR)
                szActionDescription += "Oh, stop being weird.\n";
            else if (ob[22].room != 18)
                szActionDescription += "You aren't holding it.\n";
            else
                szActionDescription += "TZZZZT!  It made sparks.\n";
        }

        private void verb_score()
        {
            szActionDescription += "Killing the lion is the only way you'll score in this game.\n";
        }

        internal void verb_save()
        {
            Microsoft.Win32.SaveFileDialog dlg = new Microsoft.Win32.SaveFileDialog();
            dlg.DefaultExt = ".sav";
            dlg.Filter = "Save files (.sav)|*.sav";
            bool? result = dlg.ShowDialog();
            if (result != null  &&  result == true)
            {
                string filename = dlg.FileName;
                StreamWriter f;
                try
                {
                    f = new StreamWriter(filename);
                }
                catch (Exception ex)
                {
                    szActionDescription += "Error creating file \"" + filename + "\":\n" + ex.Message + "\n";
                    return;
                }

                for (int i = 0; i < ob.Length; ++i)
                    f.WriteLine(ob[i].room);
                f.WriteLine(p[5].exit[0]);
                f.WriteLine(cp);
                f.WriteLine(aiming);
                f.WriteLine(drinkState);
                f.WriteLine(snakes);
                f.WriteLine(lionEatingCheese);
                f.Flush();
                f.Close();
            }
        }

        internal void LoadGame()
        {
            if (verb_load() && textBox1.Visibility != System.Windows.Visibility.Visible)
            {
                textBox1.Visibility = System.Windows.Visibility.Visible;
                textBox1.Focus();
                if (owner != null)
                    owner.EnableSaveGameMenuItem(true);
            }
            show_room();
            InvalidateVisual();
        }

        private bool verb_load()
        {
            Microsoft.Win32.OpenFileDialog dlg = new Microsoft.Win32.OpenFileDialog();
            dlg.DefaultExt = ".sav";
            dlg.Filter = "Save files (.sav)|*.sav";
            bool? result = dlg.ShowDialog();
            if (result != null && result == true)
            {
                string filename = dlg.FileName;
                StreamReader fs;
                try
                {
                    fs = new StreamReader(filename);
                }
                catch (Exception ex)
                {
                    szActionDescription += "Could not open \"" + filename + "\":\n" + ex.Message + "\n";
                    return false;
                }

                try
                {
                    string s;
                    for (int i = 0; i < ob.Length; ++i)
                    {
                        s = fs.ReadLine();
                        ob[i].room = int.Parse (s);
                    }
                    s = fs.ReadLine();
                    p[5].exit[0] = int.Parse (s);
                    s = fs.ReadLine();
                    cp = int.Parse(s);
                    s = fs.ReadLine();
                    aiming = bool.Parse(s);
                    s = fs.ReadLine();
                    drinkState = int.Parse(s);
                    s = fs.ReadLine();
                    snakes = bool.Parse(s);
                    s = fs.ReadLine();
                    lionEatingCheese = bool.Parse(s);
                    fs.Close();
                    return true;
                }
                catch (Exception ex)
                {
                    szActionDescription += "Error reading \"" + filename + "\":\n" + ex.Message + "\n";
                    // The game is now in a hopelessly mangled state.  Better give up.
                    adventure_over();
                }
            }
            return false;
        }

        private void adventure_over()
        {
            textBox1.Visibility = System.Windows.Visibility.Hidden;
            if (owner != null)
                owner.EnableSaveGameMenuItem(false);
            szActionDescription += "\n\nThe adventure has ended.\n\n";
        }
    }
}
